import React, { useState, useEffect } from 'react';
import {
  Form,
  Input,
  Button,
  Row,
  Col,
  Select,
  Radio,
  Checkbox,
  checkedValue,
  message,
  notification,
} from 'antd';
import { MinusCircleOutlined, PlusOutlined } from '@ant-design/icons';
import classnames from 'classnames';
import styles from './addForm.less';
import PicturesWall from '@/components/Upload/index';
import EditeConfigWrapper from './editConfigFileWrapper';
import CheckList from './checkBox';
import ParmarModal from './ParmarModal';

const { Item } = Form;
const { Option } = Select;
const EditForm = props => {
  const {
    submitCallback,
    nodeType,
    info,
    infoAll,
    checkList,
    configFiles,
    valueCallback = () => {},
    productList,
  } = props;
  const [form] = Form.useForm();
  const [otherForm] = Form.useForm();
  const [showParmarModal, setShowParmarModal] = useState(false);
  const [plainOptions, setPlainOptions] = useState([]); // 存储一级数据
  const [indeterminate, setIndeterminate] = useState([]);
  const [indeterminateAll, setIndeterminateAll] = useState(false);
  const [choo, setChoo] = useState(false); // 最外层复选框状态
  const layout = {
    layout: 'horizontal',
    labelCol: { span: 2 },
    wrapperCol: { span: 21 },
  };
  // 回显表单
  useEffect(() => {
    form.resetFields();
    otherForm.resetFields();
    setPlainOptions(info);
  }, [infoAll]);
  useEffect(() => {
    const targetForm = nodeType === 1 ? form : otherForm;
    let arr = Object.keys(targetForm.getFieldsValue());
    let obj = {};
    arr.map(i => {
      obj[i] = infoAll[i];
    });
    targetForm.setFieldsValue({ ...obj, shortName: infoAll.menuShortName });
    if (info.length > 0) {
      let list = [];
      info.map(item => {
        list.push(item);
      });
      let chooseData = [];
      let listData = [];
      list.forEach((item, index) => {
        chooseData.push(
          !!list[index].checkedList.size && list[index].checkedList.size < list[index].list.length,
        );
        item.list.map(i => {
          listData.push(i.related);
        });
      });
      let data = new Set();
      let datalist = [];
      info.map(item => {
        if (item.isChecked == true) {
          data.add(item.groupName);
        }
      });
      list.map((k, i) => {
        k.list.map(p => {
          datalist.push(p.related);
        });
      });
      if (data.size == info.length) {
        setChoo(true);
      } else {
        setChoo(false);
      }
      if (datalist.indexOf(true) == -1) {
        setIndeterminateAll(false);
      } else if (datalist.indexOf(false) == -1) {
        setIndeterminateAll(false);
      } else {
        setIndeterminateAll(true);
      }
      setIndeterminate(chooseData);
    }
  }, [infoAll]);

  const submit = () => {
    const targetForm = nodeType === 1 ? form : otherForm;
    let obj = targetForm.getFieldsValue();
    console.log(obj);
    console.log(plainOptions);
    let data = [];
    if (nodeType == 1) {
      plainOptions.map(item => {
        item.checkedList.forEach(i => {
          data.push(i);
        });
      });
      if (data.length > 0) {
        obj.relatedRoleList = data.toString();
      } else {
        obj.relatedRoleList = '';
      }
    }
    submitCallback(obj);
  };

  const onFinish = val => {
    submit();
  };
  // 添加功能路劲参数
  const addParama = () => {
    console.log(form.getFieldValue('pageUrl'));
    if (!form.getFieldValue('pageUrl')) {
      notification.error({ message: '提示', duration: 3, description: '请先填写功能路径' });
      return;
    }
    setShowParmarModal(true);
  };
  const radioChange = e => {};
  // 一级复选框改变事件
  const selectChange = (e, index, value) => {
    let list = [];
    plainOptions.map(item => {
      list.push(item);
    });
    list[index].isChecked = e.target.checked;
    if (e.target.checked) {
      checkList.add(list[index].groupName);
      list[index].list.map(i => {
        i.related = true;
        list[index].checkedList.add(i.relatedRoleCode);
      });
    } else {
      checkList.delete(list[index].groupName);
      list[index].list.map(i => {
        i.related = false;
        list[index].checkedList.delete(i.relatedRoleCode);
      });
    }
    const indeterminateArr = [...indeterminate];
    indeterminateArr[index] = false;
    setIndeterminate(indeterminateArr);
    let flag = [];
    let data = [];
    list.map(item => {
      if (item.isChecked == false) {
        flag.push(item);
      }
    });
    list.map((k, i) => {
      k.list.map(p => {
        data.push(p.related);
      });
    });
    if (data.indexOf(true) == -1) {
      setIndeterminateAll(false);
    } else if (data.indexOf(false) == -1) {
      setIndeterminateAll(false);
    } else {
      setIndeterminateAll(true);
    }
    if (flag.length > 0) {
      setChoo(false);
    } else {
      setChoo(true);
    }
    setPlainOptions(list);
  };
  // 二级复选框改变事件
  const handleChecked = (e, index, value, i) => {
    let list = [];
    plainOptions.map(item => {
      list.push(item);
    });
    list[index].list[i].related = e.target.checked;
    if (e.target.checked) {
      list[index].checkedList.add(list[index].list[i].relatedRoleCode);
    } else {
      list[index].checkedList.delete(list[index].list[i].relatedRoleCode);
    }
    const indeterminateArr = [...indeterminate];
    indeterminateArr[index] =
      !!list[index].checkedList.size && list[index].checkedList.size < list[index].list.length;
    setIndeterminate(indeterminateArr);
    if (
      list[index].checkedList.size == 0 ||
      list[index].checkedList.size < list[index].list.length
    ) {
      list[index].isChecked = false;
    }
    if (list[index].checkedList.size == list[index].list.length) {
      list[index].isChecked = true;
    }
    let flag = [];
    let data = [];
    list.map(item => {
      if (item.isChecked == false) {
        flag.push(item);
      }
    });
    list.map((k, i) => {
      k.list.map(p => {
        data.push(p.related);
      });
      // data.push(list[i].isChecked);
    });
    if (data.indexOf(true) == -1) {
      setIndeterminateAll(false);
    } else if (data.indexOf(false) == -1) {
      setIndeterminateAll(false);
    } else {
      setIndeterminateAll(true);
    }
    if (flag.length > 0) {
      setChoo(false);
    } else {
      setChoo(true);
    }
    setPlainOptions(list);
  };
  // 全选复选框改变事件
  const checkAll = () => {
    let list = [];
    plainOptions.map(item => {
      list.push(item);
    });
    if (choo == false) {
      indeterminate.forEach((i, j) => {
        if (i == true) {
          indeterminate[j] = false;
        }
      });
      setChoo(true);
      list.map((item, index) => {
        item.isChecked = true;
        item.list.map(i => {
          i.related = true;
          list[index].checkedList.add(i.relatedRoleCode);
        });
      });
    } else {
      setChoo(false);
      list.map((item, index) => {
        item.isChecked = false;
        item.list.map(i => {
          i.related = false;
          list[index].checkedList.delete(i.relatedRoleCode);
        });
      });
    }
    setIndeterminateAll(false);
    setPlainOptions(list);
  };
  return (
    <div style={{ marginTop: '10px' }}>
      {nodeType === 1 && (
        <Form form={form} name="editGroup" {...layout} onFinish={onFinish}>
          <Item
            label="菜单名称"
            name="menuName"
            rules={[
              {
                required: true,
                message: '请输入菜单名称',
              },
            ]}
          >
            <Input placeholder="请输入菜单名称" />
          </Item>
          <Item label="菜单别名" name="shortName">
            <Input placeholder="请输入菜单别名" />
          </Item>
          <Item label="产品类型" name="product">
            <Select placeholder="请选择产品类型" allowClear>
              {productList &&
                productList.length > 0 &&
                productList.map(item => (
                  <Option value={item.PackageName} key={item.PackageName}>
                    {item.ProductName || ''}
                  </Option>
                ))}
            </Select>
          </Item>
          <Item
            label="菜单图标"
            name="imageUrl"
            rules={[
              {
                required: true,
                message: '请选择菜单图标',
              },
            ]}
          >
            <PicturesWall picType="menuNew" />
          </Item>
          <Item label="菜单隐藏" name="hideInMenu" initialValue={false}>
            <Radio.Group onChange={radioChange}>
              <Radio value>是</Radio>
              <Radio value={false}>否</Radio>
            </Radio.Group>
          </Item>
          <Item
            name="pageUrl"
            label="功能路径"
            rules={[
              {
                required: true,
                message: '请输入功能路径',
              },
            ]}
          >
            <div style={{ display: 'flex' }}>
              <Item name="pageUrl" style={{ marginBottom: 0, width: '100%' }}>
                <Input placeholder="请输入功能路径" />
              </Item>
              <Button onClick={addParama}>添加参数</Button>
            </div>
          </Item>
          <Item label="配置文件" name="config">
            <EditeConfigWrapper>
              <Select
                allowClear
                showSearch
                filterOption={(input, option) =>
                  option.children.toLowerCase().indexOf(input.toLowerCase()) >= 0
                }
              >
                {configFiles.map(c => (
                  <Select.Option key={c.text} value={c.value}>
                    {c.text}
                  </Select.Option>
                ))}
              </Select>
            </EditeConfigWrapper>
          </Item>
          <div className={styles.boe}>
            <div
              style={{ width: '95%', marginLeft: '2%', marginTop: '10px', marginBottom: '20px' }}
            >
              <div style={{ marginTop: '-23px', backgroundColor: 'white', width: '92px' }}>
                <Checkbox
                  onChange={checkAll}
                  checked={choo}
                  nodeType={nodeType}
                  indeterminate={indeterminateAll}
                >
                  <span style={{ fontWeight: 'bold', fontSize: '15px' }}>关联角色</span>
                </Checkbox>
              </div>
              {plainOptions && plainOptions.length > 0 ? (
                plainOptions.map((item, index) => {
                  return (
                    <div
                      className={classnames({
                        [styles.divBox]: item.groupName.length > 0,
                      })}
                    >
                      <div style={{ marginTop: '-12px' }}>
                        {item.groupName.length == 0 ? (
                          <span style={{ marginLeft: '15px', marginTop: '0px' }} />
                        ) : (
                          <Checkbox
                            onChange={e => {
                              selectChange(e, index, item);
                            }}
                            checked={item.isChecked}
                            indeterminate={indeterminate[index]}
                          >
                            <span style={{ fontWeight: 'bold', fontSize: '15px' }}>
                              {item.groupName}
                            </span>
                          </Checkbox>
                        )}
                      </div>
                      <div style={{ marginLeft: '0px', marginTop: '5px' }}>
                        {item.groupName.length == 0 ? (
                          <>
                            <Row>
                              {item.list.map((val, i) => {
                                return (
                                  <Col span={4} style={{ marginBottom: '10px' }}>
                                    <Checkbox
                                      onChange={e => {
                                        handleChecked(e, index, item, i);
                                      }}
                                      checked={val.related}
                                    >
                                      {val.relatedRoleName}
                                    </Checkbox>
                                  </Col>
                                );
                              })}
                            </Row>
                          </>
                        ) : (
                          <>
                            <Row>
                              {item.list.map((val, i) => {
                                return (
                                  <Col span={4}>
                                    <Checkbox
                                      onChange={e => {
                                        handleChecked(e, index, item, i);
                                      }}
                                      checked={val.related}
                                    >
                                      {val.relatedRoleName}
                                    </Checkbox>
                                  </Col>
                                );
                              })}
                            </Row>
                          </>
                        )}
                      </div>
                    </div>
                  );
                })
              ) : (
                <span />
              )}
            </div>
          </div>
          <Item wrapperCol={{ offset: 10 }} style={{ marginTop: '20px' }}>
            <Button type="primary" htmlType="submit">
              提交
            </Button>
          </Item>
        </Form>
      )}

      {nodeType === 2 && (
        <Form form={otherForm} name="editMenu" {...layout} onFinish={onFinish}>
          <Item
            label="菜单组名称"
            name="menuName"
            rules={[
              {
                required: true,
                message: '请输入菜单组名称',
              },
            ]}
          >
            <Input />
          </Item>
          <Item label="菜单组别名" name="shortName">
            <Input placeholder="请输入菜单组别名" />
          </Item>
          <Item
            label="菜单组图标"
            name="imageUrl"
            rules={[
              {
                required: true,
                message: '请选择菜单组图标',
              },
            ]}
          >
            <PicturesWall picType="menuNew" />
          </Item>
          <Item wrapperCol={{ offset: 10 }} style={{ marginTop: '40px' }}>
            <Button type="primary" htmlType="submit">
              提交
            </Button>
          </Item>
        </Form>
      )}
      <ParmarModal
        pageUrl={form.getFieldValue('pageUrl')}
        handleCancel={() => setShowParmarModal(false)}
        visible={showParmarModal}
        parmarCallBack={url => {
          form.setFieldsValue({ pageUrl: url });
          setShowParmarModal(false);
        }}
      />
    </div>
  );
};
export default EditForm;
